/*
	[Main.cpp] for TtlMailSend.exe
	Author : Xing Yanhuan
*/



#include "WsWndBase.h"
#include "WS_MailClass.h"
#include <commctrl.h>
#include <iostream.h>
#include <fstream.h>
using namespace std;





#define APP_TITLE				TEXT("[M@[Ver.2011.03.20]")
#define APP_ERR_MSG_TITIE		TEXT("[M::G[")
#define APP_SEND_OK_MSG_TITIE	TEXT("[M::")

#define MAIL_INI_FILE		 "MailAddress.ini" // ݒt@C(g̑΃pX)
#define MAIL_INI_SECTION		 "Address"
#define MAIL_INI_SEC_HISTORY	 "History"
#define MAX_HISTROY   10

#define MAIL_INI_KEY_TO		 "To"
#define MAIL_INI_KEY_TITLE	 "Title"
#define MAIL_INI_KEY_SMTP	 "SMTP"
#define MAIL_INI_KEY_POP3	 "Pop"
#define MAIL_INI_KEY_USER	 "User"
#define MAIL_INI_KEY_PASS	 "Pass"
#define MAIL_INI_KEY_FROM	 "From"


#define CONVERT_ID_TO_SLAVE_STATIC( DlgID )  ( DlgID +1000 )
#define ID_BUTTON_EXEC			1001
#define ID_EDIT_CONTENT			1002
#define ID_EDIT_SEND_TO			1003
#define ID_EDIT_SEND_TITLE		1004

#define ID_BUTTON_SAVE			1021
#define ID_EDIT_SEND_SMTP		1022
#define ID_EDIT_SEND_POP		1023
#define ID_EDIT_SEND_ACCOUNT	1024
#define ID_EDIT_SEND_PASS		1025
#define ID_EDIT_SEND_FROM		1026

#define ID_TAB_MAIN		4000

#define ITEM_MARGI_X			 20
#define ITEM_MARGIN_Y			 40
#define ITEM_NAME_W				100
#define ITEM_NAME_SETTING_W     160
#define ITEM_TOTAL_W			420
#define ITEM_NAME_H				 24
#define ITEM_COMB_H				300

#define ITEM_TAB_H	 24
#define ITEM_BETWEEN_H	 30
#define ITEM_CONTENT_H	120
#define ITEM_EXEC_Y		 240

#define MAX_ITEM   7
static const int  gTabSendId[ MAX_ITEM ] = {
	ID_BUTTON_EXEC,
	ID_EDIT_CONTENT,
	ID_EDIT_SEND_TO,
	ID_EDIT_SEND_TITLE,
	NULL
};
static const int  gTabSettingId[ MAX_ITEM ] = {
	ID_BUTTON_SAVE,
	ID_EDIT_SEND_SMTP,
	ID_EDIT_SEND_POP,
	ID_EDIT_SEND_ACCOUNT,
	ID_EDIT_SEND_PASS,
	ID_EDIT_SEND_FROM,
	NULL
};
static const int* gTabDlgId[] = {
	gTabSendId,
	gTabSettingId,
	NULL
};


class MailDlgClass : public WsEasyWndBase{
private:
	// R}hCւ̃|C^
	char pszMailContetnsPath[ 1024 ];
	char pszIniPath[ 256 ];

	void SetArgv( void ){
		// PځiOԂ͎g̃pXjȂA[{eLXgt@Cւ̃pXƂĎ󂯎B
		// ȂΖiւ̐ݒ莞ɃG[jB
		if( __argc > 1 ){
			lstrcpy( pszMailContetnsPath, __argv[1] );

		}else{
			lstrcpy( pszMailContetnsPath, "" );
		}

		// Qڂ̃pXȂAt@C̃tpXƂĎ󂯎B
		// Ȃ΃ftHg𗘗pB
		if( __argc > 2 ){
			lstrcpy( pszIniPath, __argv[2] );
	
		}else{
			int i;
		
			GetModuleFileName( GetModuleHandle(NULL), pszIniPath, sizeof(pszIniPath)-1 );
			i = lstrlen( pszIniPath );
			while( pszIniPath[ i ]!=92 ){ //92=[\];
				i--;
			}
			lstrcpy( pszIniPath + i + 1, MAIL_INI_FILE );
		}

	}


	// t@C̗ZNVɁAɋL^ς݂ۂ`FbN
	bool IsHasSavedHistroy( char* ItemStr, char* KeyName ){
		static char pszIniKey[256];
		static char pszKeyNames[256];
		int i;

		memset( pszIniKey, 0x00, sizeof(pszIniKey) );
		memset( pszKeyNames, 0x00, sizeof(pszKeyNames) );

		for( i=0; i<MAX_HISTROY; i++){
			sprintf( pszKeyNames, "%s%d", KeyName, i );
			GetPrivateProfileString( 	MAIL_INI_SEC_HISTORY, pszKeyNames, 
										"", pszIniKey, 255, // ftHg͐ݒ肵Ȃ
										pszIniPath );
			if( 0==lstrcmp( ItemStr, pszIniKey ) ){
				// vTRUEԂB
				return true;
			}
		}
		return false;
	}
	// Mƃ^CgۑB
	bool SaveHistory( HWND hWnd ){
		char* ToPtr;
		char* TitlePtr;
		bool IsToUpdate = false;
		bool IsTitleUpdate;

		// ML^
		// ^Cgݒ
		ToPtr = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_TO );
		TitlePtr = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_TITLE );

		IsToUpdate = !IsHasSavedHistroy( ToPtr, MAIL_INI_KEY_TO );
		IsTitleUpdate = !IsHasSavedHistroy( TitlePtr, MAIL_INI_KEY_TITLE );

		if( IsToUpdate || IsTitleUpdate ){
			// t@C̗ZNV̐擪ɁAǉB
			// ToDo:ĂяopxlĒǉB
			static char pszIniKey[256];
			static char pszKeyNames[256];
			char* pszSection;
			char* MarkPtr;
			int i;
			int n;

			memset( pszIniKey, 0x00, sizeof(pszIniKey) );
			memset( pszKeyNames, 0x00, sizeof(pszKeyNames) );
			pszSection = (char*)calloc( 256*11, sizeof(char) );

			MarkPtr = pszSection;
			// Toɂ
			n = 0;
			if( IsToUpdate ){
				sprintf( MarkPtr, "%s%d=%s", MAIL_INI_KEY_TO, n, ToPtr );
				MarkPtr += lstrlen(MarkPtr) +1;
				n++;
			}
			for( i=0; i<MAX_HISTROY -1; i++){
				sprintf( pszKeyNames, "%s%d", MAIL_INI_KEY_TO, i );
				GetPrivateProfileString( 	MAIL_INI_SEC_HISTORY, pszKeyNames, 
											"None", pszIniKey, 255,
											pszIniPath );
				if( 0!=strcmp( "None", pszIniKey ) && 0!=lstrlen( pszIniKey ) ){
					sprintf( MarkPtr, "%s%d=%s", MAIL_INI_KEY_TO, n, pszIniKey );
					MarkPtr += lstrlen(MarkPtr) +1; 
					n++;
				}
			}
			// Titleɂ
			n = 0;
			if( IsTitleUpdate ){
				sprintf( MarkPtr, "%s%d=%s", MAIL_INI_KEY_TITLE, n, TitlePtr );
				MarkPtr += lstrlen(MarkPtr) +1; 
				n++;
			}
			for( i=0; i<MAX_HISTROY -1; i++){
				sprintf( pszKeyNames, "%s%d", MAIL_INI_KEY_TITLE, i );
				GetPrivateProfileString( 	MAIL_INI_SEC_HISTORY, pszKeyNames, 
											"None", pszIniKey, 255,
											pszIniPath );
				if( 0!=strcmp( "None", pszIniKey ) && 0!=lstrlen( pszIniKey ) ){
					sprintf( MarkPtr, "%s%d=%s", MAIL_INI_KEY_TITLE, n, pszIniKey );
					MarkPtr += lstrlen(MarkPtr) +1; 
					n++;
				}
			}

			// ZNVށB
			WritePrivateProfileSection( MAIL_INI_SEC_HISTORY, pszSection, 
										pszIniPath );
			free( pszSection );
		}

		DeleteStringFromDlgID( ToPtr );
		DeleteStringFromDlgID( TitlePtr );
	}

	
	// Mp[AJEg̏ۑB
	void SaveAccount( HWND hWnd ){
		char* SmtpPtr;
		char* PopPtr;
		char* IdPtr;
		char* PassPtr;
		char* FromPtr;
		char* ToPtr;
		char* TitlePtr;
		char* SectionPtr;
		char* MarkPtr;

		SmtpPtr = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_SMTP );
		PopPtr = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_POP );
		IdPtr = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_ACCOUNT );
		PassPtr = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_PASS );
		FromPtr = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_FROM );

		ToPtr = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_TO );
		TitlePtr = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_TITLE );

		SectionPtr = (char*)calloc( 256*7, sizeof(char) );
		MarkPtr = SectionPtr;
			sprintf( MarkPtr, "%s=%s", MAIL_INI_KEY_SMTP, SmtpPtr );
			MarkPtr += lstrlen(MarkPtr) +1; 

			sprintf( MarkPtr, "%s=%s", MAIL_INI_KEY_POP3, PopPtr );
			MarkPtr += lstrlen(MarkPtr) +1; 

			sprintf( MarkPtr, "%s=%s", MAIL_INI_KEY_USER, IdPtr );
			MarkPtr += lstrlen(MarkPtr) +1; 

			//MarkPtr += PassEncode20110321( MarkPtr, PassPtr ); // Í
			sprintf( MarkPtr, "%s=%s", MAIL_INI_KEY_PASS, PassPtr );
			MarkPtr += lstrlen(MarkPtr) +1; 

			sprintf( MarkPtr, "%s=%s", MAIL_INI_KEY_FROM, FromPtr );
			MarkPtr += lstrlen(MarkPtr) +1; 

			sprintf( MarkPtr, "%s=%s", MAIL_INI_KEY_TO, ToPtr );
			MarkPtr += lstrlen(MarkPtr) +1;

			sprintf( MarkPtr, "%s=%s", MAIL_INI_KEY_TITLE, TitlePtr );
			MarkPtr += lstrlen(MarkPtr) +1; 

			// ZNVށB
			WritePrivateProfileSection( MAIL_INI_SECTION, SectionPtr, 
										pszIniPath );

		free( SectionPtr );
		
		DeleteStringFromDlgID( SmtpPtr );
		DeleteStringFromDlgID( PopPtr );
		DeleteStringFromDlgID( IdPtr );
		DeleteStringFromDlgID( PassPtr );
		DeleteStringFromDlgID( FromPtr );
		DeleteStringFromDlgID( ToPtr );
		DeleteStringFromDlgID( TitlePtr );
	}

	//
	// t@ĆA̃ZNVǂݎStatic+CmbRg[B
	//
	void CreateItemWindowFromIniFile( HWND hOwnerWnd, UINT DlgCmbID, LPCTSTR ItemName, char* KeyName, int nY ){
		HWND hAny;

		CreateWindow(
			TEXT("STATIC") , ItemName,
			WS_CHILD | WS_VISIBLE | SS_LEFT ,
			ITEM_MARGI_X, nY ,
			ITEM_NAME_W	, ITEM_NAME_H ,
			hOwnerWnd , (HMENU)CONVERT_ID_TO_SLAVE_STATIC( DlgCmbID ) ,
			GetInstance() , NULL
		);
		hAny = CreateWindow(
			TEXT("COMBOBOX") , NULL,
			WS_CHILD | WS_VISIBLE | CBS_DROPDOWN | CBS_AUTOHSCROLL | WS_TABSTOP ,
			ITEM_MARGI_X + ITEM_NAME_W ,  nY,
			ITEM_TOTAL_W - ITEM_NAME_W , ITEM_COMB_H,
			hOwnerWnd , (HMENU)DlgCmbID ,
			GetInstance() , NULL
		);

		//
		// ZNV::History ǂݎBR{{bNX̃XgɐݒB
		//
		{
			static char pszIniKey[256];
			static char pszKeyNames[256];
			int i;
			
			memset( pszIniKey, 0x00, sizeof(pszIniKey) );
			memset( pszKeyNames, 0x00, sizeof(pszKeyNames) );

			for( i=0; i<MAX_HISTROY; i++){
				sprintf( pszKeyNames, "%s%d", KeyName, i );
				GetPrivateProfileString( 	MAIL_INI_SEC_HISTORY, pszKeyNames, 
											"None", pszIniKey, 255,
											pszIniPath );
				if( 0!=strcmp( "None", pszIniKey ) && 0!=lstrlen( pszIniKey ) ){
					SendMessage( hAny, CB_ADDSTRING, (WPARAM)0, (LPARAM)pszIniKey );
					if( 0==i ){
						// ͂B
						SetWindowText( hAny, pszIniKey );
					}
				}
			}
		}
		
		//
		// ZNV::Address ǂݎBR{{bNX̃eLXgɐݒB
		//
		{
			static char pszIniKey[256];
			memset( pszIniKey, 0x00, sizeof(pszIniKey) );

			GetPrivateProfileString( 	MAIL_INI_SECTION, KeyName, 
										"None", pszIniKey, 255,
										pszIniPath );

			if( 0!=strcmp( "None", pszIniKey ) && 0!=lstrlen( pszIniKey ) ){
				SetWindowText( hAny, pszIniKey );
			}
		}
	}

	//
	// t@CǂݎStatic+EditRg[(B)B
	//
	void CreateHiddenItemWindowFromIniFile( HWND hOwnerWnd, UINT DlgHiddenEditID, LPCTSTR ItemName, char* KeyName, int nY, bool IsPassword ){
		HWND hAny;

		CreateWindow(
			TEXT("STATIC") , ItemName,
			WS_CHILD | SS_LEFT ,
			ITEM_MARGI_X, nY ,
			ITEM_NAME_SETTING_W	, ITEM_NAME_H ,
			hOwnerWnd , (HMENU)CONVERT_ID_TO_SLAVE_STATIC( DlgHiddenEditID ) ,
			GetInstance() , NULL
		);
		if( IsPassword ){
			hAny = CreateWindow(
				TEXT("EDIT") , NULL,
				WS_CHILD | ES_AUTOHSCROLL | WS_TABSTOP | ES_PASSWORD ,
				ITEM_MARGI_X + ITEM_NAME_SETTING_W ,  nY,
				ITEM_TOTAL_W - ITEM_NAME_SETTING_W, ITEM_NAME_H,
				hOwnerWnd , (HMENU)DlgHiddenEditID ,
				GetInstance() , NULL
			);
		}else{
			hAny = CreateWindow(
				TEXT("EDIT") , NULL,
				WS_CHILD | ES_AUTOHSCROLL | WS_TABSTOP ,
				ITEM_MARGI_X + ITEM_NAME_SETTING_W ,  nY,
				ITEM_TOTAL_W - ITEM_NAME_SETTING_W , ITEM_NAME_H,
				hOwnerWnd , (HMENU)DlgHiddenEditID ,
				GetInstance() , NULL
			);
		}

		//
		// ZNV::Address ǂݎBR{{bNX̃eLXgɐݒB
		//
		{
			// ToDo: IsPassword==true̎AÍlׂH
			char pszIniKey[256];

			GetPrivateProfileString( 	MAIL_INI_SECTION, KeyName, 
										"None", pszIniKey, 255,
										pszIniPath );

			if( 0!=strcmp( "None", pszIniKey ) && 0!=lstrlen( pszIniKey ) ){
				//if( IsPassword ){
				//	PassDecode( pszIniKey ); // 
				//}

				SetWindowText( hAny, pszIniKey );
			}
		}
	}

	void CreateConsoleItem( HWND hWnd , UINT msg , WPARAM wp , LPARAM lp){
		int		nY;
		HWND	hAny;
		TC_ITEM	tci;

		// ^uEBhE
		InitCommonControls();
		hAny = CreateWindowEx(
			NULL,
			WC_TABCONTROL , TEXT("^u") ,
			WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_TABSTOP ,
			0 ,  0 ,
			480 , ITEM_TAB_H ,
			hWnd , (HMENU)ID_TAB_MAIN ,
			GetInstance() , NULL
		);
		tci.mask = TCIF_TEXT;
		tci.pszText = "[";
		SendMessage( hAny, TCM_INSERTITEM, (WPARAM)0, (LPARAM)&tci );
		tci.mask = TCIF_TEXT;
		tci.pszText = "ݒ";
		SendMessage( hAny, TCM_INSERTITEM, (WPARAM)1, (LPARAM)&tci );

		// ݒp{bNX - ftHg͔\
		nY = ITEM_MARGIN_Y;
		CreateHiddenItemWindowFromIniFile( hWnd, ID_EDIT_SEND_POP		, TEXT("Pop3T[o[")	, MAIL_INI_KEY_POP3, nY, false ); nY += ITEM_BETWEEN_H;
		CreateHiddenItemWindowFromIniFile( hWnd, ID_EDIT_SEND_ACCOUNT	, TEXT("Pop3AJEg")	, MAIL_INI_KEY_USER, nY, false ); nY += ITEM_BETWEEN_H;
		CreateHiddenItemWindowFromIniFile( hWnd, ID_EDIT_SEND_PASS		, TEXT("Pop3pX[h")	, MAIL_INI_KEY_PASS, nY, true  ); nY += ITEM_BETWEEN_H;
		CreateHiddenItemWindowFromIniFile( hWnd, ID_EDIT_SEND_SMTP		, TEXT("SMTPT[o[")	, MAIL_INI_KEY_SMTP, nY, false ); nY += ITEM_BETWEEN_H;
		CreateHiddenItemWindowFromIniFile( hWnd, ID_EDIT_SEND_FROM		, TEXT("MAhX")	, MAIL_INI_KEY_FROM, nY, false ); nY += ITEM_BETWEEN_H;
		// M{^ - ftHg͔\
		hAny = CreateWindow(
			TEXT("BUTTON") , TEXT("ۑ") ,
			WS_CHILD | WS_TABSTOP | BS_PUSHBUTTON | BS_DEFPUSHBUTTON ,
			ITEM_MARGI_X ,nY ,
			80 ,  24 ,
			hWnd , (HMENU)ID_BUTTON_SAVE ,
			GetInstance() , NULL
		);
		

		// mFp{bNX - ftHg\
		nY = ITEM_MARGIN_Y;
		CreateItemWindowFromIniFile( hWnd, ID_EDIT_SEND_TO,    TEXT("M"), MAIL_INI_KEY_TO, nY ); nY += ITEM_BETWEEN_H;
		CreateItemWindowFromIniFile( hWnd, ID_EDIT_SEND_TITLE, TEXT("^Cg"), MAIL_INI_KEY_TITLE, nY ); nY += ITEM_BETWEEN_H;

		// bZ[W̊mF{bNX - ftHg\
		hAny = CreateWindow(
			TEXT("EDIT") , TEXT("[") ,
			WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL | ES_READONLY | ES_MULTILINE ,
			ITEM_MARGI_X ,  nY ,
			ITEM_TOTAL_W , ITEM_CONTENT_H ,
			hWnd , (HMENU)ID_EDIT_CONTENT ,
			GetInstance() , NULL
		);
		{
		    ifstream fin( pszMailContetnsPath, ios::in | ios::binary );
			size_t fileSize;
			char*  filebuf;

			//  t@CJ
			//  ios::in ͓ǂݍݐp  ios::binary ̓oCi`

			// TCY擾
			fileSize = (size_t)fin.seekg(0, ios::end).tellg();
			fin.seekg(0, ios::beg);

			// t@Cǂݍ
			filebuf = (char*)calloc( fileSize+1, sizeof(char) );
	        fin.read( filebuf, fileSize );

			//t@C
			fin.close();

			// t@C̒g𑋂ɐݒ
			SetWindowText( hAny, filebuf );

			// obt@J
			free( filebuf );
		}

		// M{^ - ftHg\
		hAny = CreateWindow(
			TEXT("BUTTON") , TEXT("M") ,
			WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_PUSHBUTTON | BS_DEFPUSHBUTTON ,
			ITEM_MARGI_X , ITEM_EXEC_Y ,
			80 ,  24 ,
			hWnd , (HMENU)ID_BUTTON_EXEC ,
			GetInstance() , NULL
		);
		SetFocus( hAny );
	}


	//
	// Rg[̕擾āAobt@mۂĕԂ
	//
	char* CreateStringFromDlgID( HWND hWnd, int nIDDlgItem ){
		int   nLength;
		char* TextBuf;
		HWND  hEdit;
			
		hEdit = GetDlgItem( hWnd, nIDDlgItem );
		nLength = GetWindowTextLength( hEdit );

		TextBuf = (char*)calloc( nLength+1, sizeof(char) );
		GetWindowText( hEdit, TextBuf, nLength+1 );
		return TextBuf;
	}
	// L̃obt@JB
	void  DeleteStringFromDlgID( char* TextBuf ){
		free( TextBuf );
	}


	// Mp[^\`FbNBG[Ȃ烁bZ[W{bNXoB
	bool IsParameterOK( HWND hWnd ){
		char* AnyTextPtr;
		static char pszErrMsg[1024];
		bool IsAboutIniFile = false;

		memset( pszErrMsg, 0x00, sizeof(pszErrMsg) );

		if( 0 == GetWindowTextLength( GetDlgItem( hWnd, ID_EDIT_SEND_SMTP ) ) ){
			lstrcpy( pszErrMsg, "SmtpT[oݒ肳Ă܂" );
			IsAboutIniFile = true;
			goto LABEL_IS_PARAMETER_ERROR;
		}
		if( 0 == GetWindowTextLength( GetDlgItem( hWnd, ID_EDIT_SEND_POP ) ) ){
			lstrcpy( pszErrMsg, "Pop3T[oݒ肳Ă܂" );
			IsAboutIniFile = true;
			goto LABEL_IS_PARAMETER_ERROR;
		}
		if( 0 == GetWindowTextLength( GetDlgItem( hWnd, ID_EDIT_SEND_ACCOUNT ) ) ){
			lstrcpy( pszErrMsg, "[T[oUser(AJEgID)ݒ肳Ă܂" );
			IsAboutIniFile = true;
			goto LABEL_IS_PARAMETER_ERROR;
		}
		if( 0 == GetWindowTextLength( GetDlgItem( hWnd, ID_EDIT_SEND_PASS ) ) ){
			lstrcpy( pszErrMsg, "[T[oPasswordݒ肳Ă܂" );
			IsAboutIniFile = true;
			goto LABEL_IS_PARAMETER_ERROR;
		}
		if( 0 == GetWindowTextLength( GetDlgItem( hWnd, ID_EDIT_SEND_TO ) ) ){
			lstrcpy( pszErrMsg, "M悪ݒ肳Ă܂" );
			goto LABEL_IS_PARAMETER_ERROR;
		}
		if( 0 == GetWindowTextLength( GetDlgItem( hWnd, ID_EDIT_SEND_TITLE ) ) ){
			lstrcpy( pszErrMsg, "[^Cgݒ肳Ă܂" );
			goto LABEL_IS_PARAMETER_ERROR;
		}
		if( 0 == GetWindowTextLength( GetDlgItem( hWnd, ID_EDIT_CONTENT ) ) ){
			lstrcpy( pszErrMsg, "[{ݒ肳Ă܂" );
			goto LABEL_IS_PARAMETER_ERROR;
		}

		return true;

LABEL_IS_PARAMETER_ERROR:
		if( IsAboutIniFile ){
			lstrcat( pszErrMsg, "\r\n\r\n[ݒmFĂB\r\nݒ^uJ܂H" );
			if( IDYES==MessageBoxA( hWnd, pszErrMsg, APP_ERR_MSG_TITIE, MB_YESNO | MB_DEFBUTTON1 ) ){
				SendMessage( GetDlgItem( hWnd, ID_TAB_MAIN ), TCM_SETCURSEL, 1, 0 );
				// ^u̕\ԂXVB
				UpdateTabShow( hWnd );
			}
		}else{
			MessageBoxA( hWnd, pszErrMsg, APP_ERR_MSG_TITIE, MB_OK );
		}
		return false;
	}

	//
	// ^u̕\ԂXVB
	//
	void UpdateTabShow( HWND hWnd ){
		int* nIDDlgItemArray;
		int  nIDDlgItem;
		int  nCmdShow;
		int nPage;
		nPage = SendMessage( GetDlgItem( hWnd, ID_TAB_MAIN ), TCM_GETCURSEL, 0, 0 );

		// ^uƂɕ\Rg[؂ւB
		for( int n=0; NULL!=gTabDlgId[ n ]; n++ ){
			// \^\ݒ
			nCmdShow = ( nPage == n ) ? SW_SHOW : SW_HIDE;
			// ΉRg[Xg擾
			nIDDlgItemArray = (int*)gTabDlgId[ n ];
			// \؂ւB
			for( int i=0; NULL!=nIDDlgItemArray[ i ]; i++ ){
				nIDDlgItem = nIDDlgItemArray[ i ];
				ShowWindow( GetDlgItem( hWnd, nIDDlgItem ), nCmdShow );

				nIDDlgItem = CONVERT_ID_TO_SLAVE_STATIC( nIDDlgItem );
				ShowWindow( GetDlgItem( hWnd, nIDDlgItem ), nCmdShow );
			}
		}
	}


	void SendMailExec( HWND hWnd ){
		Mail objMail;
		MailTransporter objMailer;
		char* AnyTextPtr;

		// p[^̃`FbN
		if( false==IsParameterOK( hWnd ) ){
			// ĂяoŃG[bZ[WoĂ̂ŁA͔邾B
			return;
		}


		// Popݒ
		{
			char* Pop3Address;
			char* Pop3Id;
			char* Pop3Pass;
			Pop3Address = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_POP );
			Pop3Id = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_ACCOUNT );
			Pop3Pass = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_PASS );

				objMailer.setPop3( Pop3Address, Pop3Id, Pop3Pass );

			DeleteStringFromDlgID( Pop3Address );
			DeleteStringFromDlgID( Pop3Id );
			DeleteStringFromDlgID( Pop3Pass );
		}

		// SMTPݒ
		AnyTextPtr = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_SMTP );
		objMailer.setSmtp( AnyTextPtr );
		DeleteStringFromDlgID( AnyTextPtr );

		// Mݒ
		AnyTextPtr = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_FROM );
		if( 0==lstrlen( AnyTextPtr ) ){
			// ݒ肪ꍇ́APop̃AJEgIDőpB
			DeleteStringFromDlgID( AnyTextPtr );
			AnyTextPtr = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_ACCOUNT );
		}
		objMail.setFrom( AnyTextPtr );
		DeleteStringFromDlgID( AnyTextPtr );

		// Mݒ
		AnyTextPtr = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_TO );
		objMail.setTo( AnyTextPtr );
		DeleteStringFromDlgID( AnyTextPtr );

		// ^Cgݒ
		AnyTextPtr = CreateStringFromDlgID( hWnd, ID_EDIT_SEND_TITLE );
		objMail.setSubject( AnyTextPtr );
		DeleteStringFromDlgID( AnyTextPtr );

		// {ݒ
		AnyTextPtr = CreateStringFromDlgID( hWnd, ID_EDIT_CONTENT );
		objMail.setBody( AnyTextPtr );
		DeleteStringFromDlgID( AnyTextPtr );

		// [M
		{
			char pszErrMsg[1024];
			if( objMailer.send( objMail ) ){
				wsprintf( pszErrMsg, "Đ : %s \r\nILbg[őM܂B", objMail.getTo().c_str() );
				MessageBoxA( hWnd, pszErrMsg, APP_SEND_OK_MSG_TITIE, MB_OK );

				// ۑB
				SaveHistory( hWnd );

				// AvIB
				SendMessage( hWnd, WM_CLOSE, NULL, NULL );

			}else{
				wsprintf( pszErrMsg, "MɎs܂F\r\n\r\n%s", objMailer.GetErrorMsg() );
				MessageBoxA( hWnd, pszErrMsg, APP_ERR_MSG_TITIE, MB_OK );
			}
		}

		return;
	}

public:
	MailDlgClass(){
	}
	~MailDlgClass(){
	}


	bool StartWnd( 
		HINSTANCE hInstance , HINSTANCE hPrevInstance ,
		PSTR lpCmdLine , int nCmdShow )
	{
		int RetuneCode;
		SetInstance( hInstance );
		SetArgv(); // (char*)lpCmdLine ͗pȂBu__argvvőցBB
		SetBockGroundColorStock( LTGRAY_BRUSH );
		RetuneCode = CreateWnd( 
				NULL, 
				TEXT("MailSendDlgWndClass"), APP_TITLE, TEXT("MailSendMenu"), NULL, 
				480, 320,
				NULL 
				);
		if( false==RetuneCode ){	return 1; }

		return MessageLoop();
	}

	int IsUserEvent( HWND hWnd , UINT msg , WPARAM wp , LPARAM lp){
		switch (msg){
		case WM_CREATE:
			CreateConsoleItem( hWnd , msg , wp , lp );
			return 0;

		//case WM_SIZE:
		//	MoveWindow( hListView , 0 , SchdManagerConsoleHeight , LOWORD(lp) , HIWORD(lp) , FALSE );
		//	return 0;

		case WM_COMMAND:
			switch ( LOWORD(wp) ){
			case ID_BUTTON_EXEC:
				SendMailExec( hWnd );
				break;

			case ID_BUTTON_SAVE:
				SaveAccount( hWnd );
				break;
			}
			break;

		case WM_NOTIFY:
            switch (((NMHDR *)lp)->code) {
                // Ⴄy[Wꂽ
                case TCN_SELCHANGE:
					// ^u̕\ԂXVB
					UpdateTabShow( hWnd );
					break;
            }
			break;

		}

		return DefWindowProc( hWnd , msg , wp , lp );
	}

};




int WINAPI WinMain(HINSTANCE hInstance , HINSTANCE hPrevInstance ,
			PSTR lpCmdLine , int nCmdShow) {

	bool RetuneCode;
	MailDlgClass wsEW;

	RetuneCode = wsEW.StartWnd( NULL, hInstance, lpCmdLine, nCmdShow );
	return RetuneCode;
}







